import QtQuick
import QtQuick.Controls

Window {
    id: root

    width: 640
    height: 480

    visibility: Window.FullScreen
    visible: true

    StackView{
        id: stackView
        initialItem: pluginPanel

        popEnter: Transition {
            XAnimator {
                from: (stackView.mirrored ? -1 : 1) * -stackView.width
                to: 0
                duration: 1000
            }
        }

        popExit: Transition {
            XAnimator {
                from: 0
                to: (stackView.mirrored ? -1 : 1) * stackView.width
                duration:  1000
            }
        }


        anchors{
            fill:parent
            topMargin: 15
            bottomMargin: 15
        }
    }

    Connections{
        id: connectionsItemStackView

        target:stackView.currentItem
        ignoreUnknownSignals: true


        function onPluginRequested(pluginID)
        {
            pluginHandler.handlePlugin(pluginID)
            stackView.push(pluginLoader)
        }
    }

    Connections{
        id: connectionspluginHandler

        target: pluginHandler
        function onPluginDone()
        {
            stackView.popToIndex(0, StackView.PopTransition)
        }
    }

    Component {
        id: pluginPanel

        PluginsPanel{
        }
    }

    Component {
        id: pluginLoader

        PluginLoader{
        }
    }

}
