import QtQuick
GridView {

    id: root
    signal pluginRequested(string pluginID)

    clip:true

    model: pluginsPanelModel

    cellWidth: 200
    cellHeight: 200


    delegate: Column {
        spacing : 35

        MouseArea {
            id: mouseArea
            width: 160
            height: 180
            anchors.horizontalCenter: parent.horizontalCenter
            scale: pressed? 0.8 : 1

            Image {width: 64; height: 64;
                id: itemIcon
                anchors.horizontalCenter: parent.horizontalCenter

                source: pluginIcon

                fillMode: Image.PreserveAspectFit
            }
            Text { text: pluginName

                anchors.top: itemIcon.bottom;
                anchors.horizontalCenter: parent.horizontalCenter;
                width: 140
                anchors.topMargin: 10
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                horizontalAlignment: Text.AlignHCenter
            }

            onClicked:{
                pluginRequested(pluginName)                
            }
        }
    }
}
