#include "pluginhandler.h"
#include "pluginspanelmodel.h"
#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>

int main(int argc, char *argv[]) {
  QGuiApplication app(argc, argv);
  app.setApplicationDisplayName(QObject::tr("Coffee Plugin Demo"));

  QQmlApplicationEngine engine;

  PluginsContainer pluginsContainer;

  PluginsPanelModel pluginsPanelModel(&pluginsContainer);
  PluginHandler pluginHandler(&pluginsContainer, engine.rootContext());

  engine.rootContext()->setContextProperty("pluginHandler", &pluginHandler);

  engine.rootContext()->setContextProperty("pluginsPanelModel",
                                           &pluginsPanelModel);

  QObject::connect(
      &engine, &QQmlApplicationEngine::objectCreationFailed, &app,
      []() { QCoreApplication::exit(-1); }, Qt::QueuedConnection);
  engine.loadFromModule("DemoPlugin", "Main");

  // Plugin Viewer (1.5 hours)
  // Plugin Model  (2 hours)

  // Plugin Loader 2 hours
  // Plugin container 2 hours
  // Do a plugin with a screen (3 hours with breaks)

  // 3 days to do

  // Slides (start 2 hours)
  // Slide 1 Normal Architecture
  // Slide 2 Plugin Architecture (Contract, Namespace)
  // Slide 3 Why do this?
  // Slide 4 What is a plugin?
  // Examples (Settings on a dash, Games console, Add-ons in Webbrowser)
  // In our Example coffee machine with many recipes.
  // Finding the Plugin
  // Plugin Interface
  // Loading a plugin
  // Invoking a plugin

  return app.exec();
}
