#pragma once
#include <QObject>
#include <QQmlEngine>

class QQmlContext;
class PluginsContainer;
class CoffeeWorkflowController;

class PluginHandler : public QObject {
  Q_OBJECT

  Q_PROPERTY(QUrl currentScreen READ currentScreen WRITE setCurrentScreen NOTIFY
                 currentScreenChanged)

public:
  explicit PluginHandler(PluginsContainer *pluginsContainer, QQmlContext *,
                         QObject *parent = nullptr);

  QUrl currentScreen() const;
  void setCurrentScreen(const QUrl &newCurrentScreen);

  Q_INVOKABLE void handlePlugin(const QString &);

signals:
  void currentScreenChanged();
  void pluginDone();

private:
  QUrl m_currentScreen;
  PluginsContainer *m_pluginsContainer;
  QQmlContext *m_qmlContext;
  CoffeeWorkflowController *m_currentCoffeeWorkflowController;
};
