#pragma once

#include <QUrl>
#include <QMap>
#include <QObject>
#include <QString>

class CoffeePlugin;

class PluginsContainer : public QObject {
  Q_OBJECT

public:
  explicit PluginsContainer(QObject *parent = nullptr);
  void populateContainer();

  int pluginsCount() const;
  QString pluginName(int) const;
  QUrl pluginIcon(const QString &) const;

  CoffeePlugin *coffeePlugin(const QString &) const;

private:
  QMap<QString, CoffeePlugin *> m_container;
};
