#include "pluginspanelmodel.h"

PluginsPanelModel::PluginsPanelModel(PluginsContainer *plugins, QObject *parent)
    : QAbstractListModel(parent), m_pluginsContainer(plugins) {}

int PluginsPanelModel::rowCount(const QModelIndex &parent) const {
  if (parent.isValid())
    return 0;

  return m_pluginsContainer->pluginsCount();
}

QVariant PluginsPanelModel::data(const QModelIndex &index, int role) const {
  if (!index.isValid() || index.row() >= m_pluginsContainer->pluginsCount()) {
    return QVariant();
  }

  switch (role) {
  case PluginNameRole:
    return m_pluginsContainer->pluginName(index.row());
    break;

  case PluginIcon:
    return m_pluginsContainer->pluginIcon(
        m_pluginsContainer->pluginName(index.row()));
    break;
  }

  return QVariant();
}

QHash<int, QByteArray> PluginsPanelModel::roleNames() const {
  QHash<int, QByteArray> roles;
  roles[PluginNameRole] = "pluginName";
  roles[PluginIcon] = "pluginIcon";
  return roles;
}
