#pragma once

#include <QAbstractListModel>

#include "pluginscontainer.h"
#include <memory>

class PluginsPanelModel : public QAbstractListModel {
  Q_OBJECT

public:
  enum { PluginNameRole = Qt::UserRole, PluginIcon };

  explicit PluginsPanelModel(PluginsContainer *plugins,
                             QObject *parent = nullptr);

  int rowCount(const QModelIndex &parent = QModelIndex()) const override;

  QVariant data(const QModelIndex &index,
                int role = Qt::DisplayRole) const override;

private:
  PluginsContainer *m_pluginsContainer;
  QHash<int, QByteArray> roleNames() const override;
};
