#include "esspressocoffeeworkflowcontroller.h"
#include "esspressoworkflowqmldata.h"
#include <QDebug>
#include <QTimer>

EsspressoCoffeeWorkflowController::EsspressoCoffeeWorkflowController(
    QObject *parent)
    : QObject(parent), CoffeeWorkflowController(),
      m_EsspressoWorkflowData(new EsspressoWorkflowQMLData(this)) {

  connect(m_EsspressoWorkflowData,
          &EsspressoWorkflowQMLData::notifyQuitPluginRequest, this,
          [this] { endUiWorkFlow(); });
}

void EsspressoCoffeeWorkflowController::startWork(const QVariantMap &) {

  beginUiWorkflow();
}

QUrl EsspressoCoffeeWorkflowController::mainPanelQmlUrl() const {

  return QUrl("qrc:/EsspressoPlugin/MainEsspressoPanel.qml");
}

QObject *EsspressoCoffeeWorkflowController::qmlPresenterData() const {
  return m_EsspressoWorkflowData;
}

void EsspressoCoffeeWorkflowController::destroy() { deleteLater(); }
